package cc.fascinated.bat.command.impl.server;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.CommandInfo;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "premium", description = "View the premium information for the guild", requiredPermissions = Permission.ADMINISTRATOR)
public class PremiumCommand extends BatCommand {
    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, @NonNull SlashCommandInteraction interaction) {
        BatGuild.Premium premium = guild.getPremium();
        EmbedBuilder embed = EmbedUtils.genericEmbed().setAuthor("Premium Information");
        if (premium.hasPremium()) {
            embed.addField("Premium", premium.hasPremium() ? "Yes" : "No", true);
            embed.addField("Started", "<t:%d>".formatted(premium.getActivatedAt().toInstant().toEpochMilli() / 1000), true);
            embed.addField("Expires", premium.isInfinite() ? "Never" : "<t:%d>"
                    .formatted(premium.getExpiresAt().toInstant().toEpochMilli() / 1000), true);
        } else {
            embed.setDescription("The guild does not have premium");
        }
        interaction.replyEmbeds(embed.build()).queue();
    }
}
