package cc.fascinated.bat.features.spotify;

import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.features.Feature;
import net.dv8tion.jda.api.entities.MessageEmbed;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class SpotifyFeature extends Feature {
    @Autowired
    public SpotifyFeature() {
        super("Spotify", Category.MUSIC);
    }

    /**
     * The embed for when a user needs to link their Spotify account.
     *
     * @return The embed.
     */
    public static MessageEmbed linkAccountEmbed() {
        return EmbedUtils.genericEmbed()
                .setDescription("You need to link your Spotify account before you can use this command.")
                .build();
    }
}
