package cc.fascinated.bat.features.spotify.command;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "spotify", description = "Change your Spotify settings", guildOnly = false, category = Category.MUSIC)
public class SpotifyCommand extends BatCommand {
    @Autowired
    public SpotifyCommand(@NonNull ApplicationContext context) {
        super.addSubCommand(context.getBean(LinkSubCommand.class));
        super.addSubCommand(context.getBean(UnlinkSubCommand.class));
        super.addSubCommand(context.getBean(PauseSubCommand.class));
        super.addSubCommand(context.getBean(ResumeSubCommand.class));
        super.addSubCommand(context.getBean(CurrentSubCommand.class));
    }
}
