package cc.fascinated.bat.features.spotify.profile;

import cc.fascinated.bat.common.Profile;
import lombok.Getter;
import lombok.Setter;

/**
 * @author Fascinated (fascinated7)
 */
@Getter @Setter
public class SpotifyProfile extends Profile {
    /**
     * The access token
     */
    private String accessToken;

    /**
     * The refresh token
     */
    private String refreshToken;

    /**
     * When the access token expires
     */
    private Long expiresAt;

    public SpotifyProfile() {
        super("spotify");
    }

    /**
     * Checks if the account has a linked account
     *
     * @return if the account has a linked account
     */
    public boolean hasLinkedAccount() {
        return this.accessToken != null && this.refreshToken != null;
    }

    @Override
    public void reset() {
        this.accessToken = null;
        this.refreshToken = null;
    }
}
